<?php

/*****************************************************************************
Functions to show alternative spellings and familylines. For tng mod show all family. DuPree 2023
*****************************************************************************/

check_create_showalltable (); // on every include check to see if the table is installed and if not install it

// Unused descendants function - takes too long
function saf_desc_gen ( $personID, $tree, $gens ) {				
global $showall_table, $children_table, $people_table;
$dcount = 0;
$childinfo[] = array("pid"=>$personID);
for ($i = 0; $i < $gens; $i++) {
    foreach ($childinfo as $key => $ci) {  
        $d = $ci['pid'];
		unset($childinfo[$key]);
		$childquery = 'SELECT personID 
		FROM '.$children_table.' 
		WHERE familyID in (SELECT familyID FROM `tng_families` WHERE (husband = "'.$d.'" OR wife = "'.$d.'") AND gedcom="'.$tree.'" )';
		$result = tng_query($childquery);
			if(tng_num_rows($result) >0 ) {
				while( $children = tng_fetch_assoc( $result ) ) {
				$childinfo[] = array("pid"=>$children['personID']);
				$tlist .= $children['personID']. ' - '; 
				$dcount++;
				}
			}
	}
}
return 'PersonID = '.$personID.' Descendants = '.$dcount.' Generations = '.$i.' tlist = '.$tlist.'<br>';
}

// adds plus sign to an individuals surname - tied to drawheading
function plus_associated_surnames ( $personID, $tree ) {			
	global $textpart;
	$anas=$tname=$include_js=$anames='';
	$tresult = getPersonFullPlusDates($tree, $personID);
	$trow = tng_fetch_assoc($tresult);
	$tname = $trow['lastname'];
	if ($tname !='' ) $anas = associated_surnames( $personID, $tree, $tname );
	if ($anas != '') {
	$anames  = "<span  id='xonspan' style='font-size:small;' ><a href='#' id='xsuron' style='text-decoration: none;' > + </a></span>";
	$anames .= "<span id='xoffspan' style='font-size:large;display:none;' ><a href='#' id='xsuroff' style='text-decoration: none;color:blue;' > - <a></span>";
	$anames .= "<span id='otnames' style='display:none;font-size:small;' >" . $anas . "</span>";
	}
	else $anames = '';
if ($anames != '') $include_js = '
<script>
    $(document).ready(function(){
        $("#nameheader").append("'.$anames.'");
            $( "#xsuron" ).click(function() {
   				 $( "#otnames" ).toggle();
   				 $( "#xoffspan" ).toggle();
   				 $( "#xonspan" ).toggle();

			});
			$( "#xsuroff" ).click(function() {
   				 $( "#otnames" ).toggle();
   				 $( "#xoffspan" ).toggle();
   				 $( "#xonspan" ).toggle();

			});

    });
</script>
';
return $include_js;
}

function array_iunique( $array ) {  							// returns an array with duplicates removed
    return array_intersect_key(
        $array,
        array_unique( array_map( "strtolower", $array ) )
    );
}

function get_family_notes($wifearray, $tree){					// gets married notes for a family
	global $xnotes_table, $notelinks_table, $text;	
	$notes = ''; $i=1;
	if (!isset($wifearray)) $notes = 'Empty array'; 
	    else {
			foreach ($wifearray as $wid) {
			$query = "SELECT note FROM $xnotes_table a JOIN  $notelinks_table b ON b.xnoteID = a.ID AND b.gedcom  = '" . $tree . "' AND a.gedcom  = '" . $tree . "' WHERE persfamID = '" . $wid['fid'] ."'";
			$result = tng_query($query);
    			foreach ($result as $fn) {
   				$notes .= $fn['note'].'<br><br>';
    			$i++;
    			}
     		}
     	}
if ($notes == '') $notes = "No Notes";		
return $notes;
}

function get_spelling_data($personID, $tree){							// get spelling data if it exists
global $showall_table;
$spellings = '';
$lastdad = get_last_dad ($personID, $tree);
$sdata = get_showall_data($lastdad, $tree);
$spellings = $sdata['spellings'];
return $spellings;
}

function get_showall_data($lastdad, $tree){						// just gets all the data from showall table
	global $showall_table;	
	$query = "SELECT spellings, descendants, generations FROM $showall_table WHERE root_personID = '" . $lastdad ."' AND gedcom = '" . $tree . "'";
	$result = tng_query($query);
    $sprow = tng_fetch_assoc( $result ); 
return $sprow;
}

function get_great_grandparents($personID, $tree, $iGG){
    global $children_table, $families_table;
    if (isset($_SESSION['linegens'])) $gens = $_SESSION['linegens']; else $gens = 3;
    $gens = $gens+1;
	$parentinfo[] = array("pid"=>$personID,"gen"=>"parents", "gen_num" => 0, "child" => "initial", "spouse" => "", "sex"=> "?");
	$t_array[]= array("pid"=>$personID);
	for ($i = 1; $i < $gens; $i++) {
		$s_array = $t_array;
		$t_array = array();
	   	foreach ($s_array as $parent) { 
    	$child = $parent['pid'];
       	$result = getChildParentsFamilyMinimal($tree, $parent['pid']);
			while( $parents = tng_fetch_assoc( $result ) ) {
			    $pid = $parent['pid'];
			    if ($i == 0) $gen = 'parents'; if ($i == 1) $gen = 'grandparents'; if ($i == 2) $gen = 'ggrandparents'; if ($i == 3) $gen = 'gggrandparents'; if ($i == 4) $gen = 'ggggrandparents'; if ($i == 5) $gen = 'gggggrandparents'; if ($i == 6) $gen = 'ggggggrandparents'; if ($i == 7) $gen = 'gggggggrandparents';
				if (($key = array_search($pid, $parentinfo)) !== false) unset($parentinfo[$key]);
				if( $parents['husband'] != '') {
				        $wife = $parents['wife'];
				 		$parentinfo[]= array("pid"=>$parents['husband'],"gen"=>$gen, "gen_num" => $i, "child" => $child, "spouse" => $wife, "sex" => 'm');
						$t_array[] = array("pid" => $parents['husband'] );
						if($iGG == $parents['husband']) break;
				        }
				if( $parents['wife'] != '') {
						$husband = $parents['husband'];
						$parentinfo[] = array("pid"=>$parents['wife'],"gen"=>$gen, "gen_num" => $i, "child" => $child, "spouse" => $husband, "sex" => 'f');
						$t_array[] = array("pid" => $parents['wife'] );
						if($iGG == $parents['wife']) break;
						}
			} //while
		tng_free_result( $result );
		} //foreach
     } // for i
	return $parentinfo;
}

function the_root_gal ($personID, $tree, $sex){
	global $people_table, $children_table;
	$mother=$parents=''; 
$mother = '';
	$family = get_ldfamilyID ($personID, $tree);
	$parents = get_ldparents_of ( $family, $tree);
	if (!empty($parents["wife"])){
	  $startmaternal = 1; 
	  $mother = $personID;
	  $reltree[0] = array("pid" => $personID, "gen" => 0, "loc" => 'firstguy', "sex" => $sex);
	}
	else {
	  $startmaternal = 1; 	
	  $mother = '';
	  $reltree[0] = array("pid" => $personID, "gen" => 0, "loc" => 'lastdad', "sex" => $sex);
	}

	while ($startmaternal < 65 && $mother != ''){
		if ($mother != '') {
			$family = get_ldfamilyID ($mother, $tree);
			$parents = get_ldparents_of ($family, $tree);
			if ($parents != "" AND $parents['wife'] != '' ){
				$father = $parents["husband"];
				$mother = $parents["wife"];
				$lastdad = $mother;
				$reltree[] = array("pid" => $mother, "gen" => $startmaternal, "loc" => "", "sex" => 'F', "spouse" => $father);
			} // parents not empty
			else {
				$lastdad = $father;
				$reltree[] = array("pid" => $mother, "gen" => $startmaternal, "loc" => "lastdad", "sex" => 'F', "spouse" => $father);
				$mother = '';
			}
		}	//mother not empty
		$startmaternal = $startmaternal+1;
	} //while

	return $reltree;
} // function

function the_root_guy ($personID, $tree, $sex){
	global $people_table, $children_table;
	$father=$parents=''; 
$father = '';
	$family = get_ldfamilyID ($personID, $tree);
	$parents = get_ldparents_of ( $family, $tree);
	if (isset($parents["husband"])){
	  $startpaternal = 1; 
	  $father = $personID;
	  $reltree[0] = array("pid" => $personID, "gen" => 0, "loc" => 'firstguy', "sex" => $sex);
	}
	else {
	  $startpaternal = 1; 	
	  $father = '';
	  $reltree[0] = array("pid" => $personID, "gen" => 0, "loc" => 'lastdad', "sex" => $sex);
	}

	while ($startpaternal < 65 && $father != ''){
		if ($father != '') {
			$family = get_ldfamilyID ($father, $tree);
			$parents = get_ldparents_of ($family, $tree);
			if ($parents != "" AND $parents['husband'] != '' ){
				$father = $parents["husband"];
				$mother = $parents["wife"];
				$lastdad = $father;
				$reltree[] = array("pid" => $father, "gen" => $startpaternal, "loc" => "", "sex" => 'm', "spouse" => $mother);
			} // parents not empty
			else {
				$lastdad = $father;
				$reltree[] = array("pid" => $father, "gen" => $startpaternal, "loc" => "lastdad", "sex" => 'm', "spouse" => $mother);
				$father = '';
			}
		}	//father not empty
		$startpaternal = $startpaternal+1;
	} //while

	return $reltree;
} // function

function get_last_dad($personID, $tree){
	global $people_table, $children_table;
	$father=$parents=''; 
	$startpaternal = 1;
//	get_saf_family($personID, $tree);
	$family = get_ldfamilyID ($personID, $tree);
	$parents = get_ldparents_of ( $family, $tree);
	if ($parents != ""){
	  $father = $parents["husband"];
	  $lastdad = $father;
	}
	else {
		$father = '';
		$lastdad = '';
		$startpaternal = 100;
	}

	if ($father == '' )	{
		$MySQL = "SELECT sex FROM $people_table WHERE personID = '" . $personID ."' AND gedcom = '" . $tree . "'";
		$Result = tng_query($MySQL);
		$Row = tng_fetch_assoc($Result);
		if ($Row['sex'] == "M" )
			$lastdad = $personID;
	}

	while ($startpaternal < 65 && $father != ''){
		if ($father != '') {
//		    if ($_SESSION['saf_ck_table'] == '') get_saf_family($father, $tree);
			$family = get_ldfamilyID ($father, $tree);
			$parents = get_ldparents_of ($family, $tree);
			if ($parents != "" AND $parents['husband'] != '' ){
				$father = $parents["husband"];
				$lastdad = $father;
			} // parents not empty
			else {
				$lastdad = $father;
				$father = '';
			}
		}	//father not empty
		$startpaternal = $startpaternal+1;
	} //while
	return $lastdad;
} // function

function get_ldfamilyID ($personID, $tree){
	global $people_table, $children_table;
	//do parents
	$MySQL = "SELECT familyid FROM $children_table WHERE personid = '" . $personID ."' AND gedcom = '" . $tree . "' AND (frel = '' or frel = 'birth' or frel ='sealing' ) AND (mrel = '' or mrel = 'birth' or mrel ='sealing' )";
    $Result = tng_query($MySQL);
	if (tng_num_rows($Result) == 1){
		$Row = mysqli_fetch_assoc($Result);
		return $Row["familyid"];
	}else{
		$MySQL = "SELECT familyid FROM $children_table WHERE personid = '" . $personID ."' AND gedcom = '" . $tree . "' AND (frel = 'adopted' OR frel = 'putative') ";
    	$Result = tng_query($MySQL);
		if (mysqli_num_rows($Result) == 1){
			$Row = mysqli_fetch_assoc($Result);
			return $Row["familyid"];
		}
		else
			return "";
	}
} // function

function get_ldparents_of ($FamilyID, $Tree){
	global $families_table;
	$MySQL = "SELECT husband, wife FROM $families_table WHERE familyID = '" . $FamilyID ."' AND gedcom = '" . $Tree . "'";
	$Result = tng_query($MySQL);
	if (tng_num_rows($Result) == 1){
		$Row = tng_fetch_assoc($Result);
		return $Row;
	}else
		return "";
}

function get_mom_last ($personID, $tree){
	global $people_table;
	$MySQL = "SELECT lastname FROM $people_table WHERE personID = '" . $personID ."' AND gedcom = '" . $tree . "'";
	$Result = tng_query($MySQL);
	if (mysqli_num_rows($Result) == 1){
		$Row = mysqli_fetch_assoc($Result);
		$mlast = $Row['lastname'];
//		$mlast = str_replace(' ', '', strtolower($mlast));
		return $mlast;
	}else
		return "";
}

function get_child_last ($personID, $tree){
	global $people_table;
	$MySQL = "SELECT lastname FROM $people_table WHERE personID = '" . $personID ."' AND gedcom = '" . $tree . "'";
	$Result = tng_query($MySQL);
	if (mysqli_num_rows($Result) == 1){
		$Row = mysqli_fetch_assoc($Result);
		$clast = $Row['lastname'];
//		$clast = str_replace(' ', '', strtolower($clast));
		return $clast;
	}else
		return "";
}


function get_desc_names($personID, $getperson_url, $tree){
	global $people_table, $children_table;
	$start = 1;
	$checker = '';

	$query = "SELECT sex FROM $people_table WHERE personid = '" . $personID ."' AND gedcom = '" . $tree . "' ";
	$result =  tng_query($query);
	$row = tng_fetch_assoc( $result );
 	if ($row['sex'] = "M")
		$family = get_pschildrenID ($personID, $tree);

	while ($start < 150 ){
		foreach ($family as $fams){

			$query = "SELECT personID, lastname FROM $people_table WHERE sex = 'M' AND personID IN (SELECT personID FROM $children_table WHERE familyID = '" . $fams['familyID'] ."' AND gedcom = '" . $tree . "' AND (frel = '' or frel = 'birth' or frel ='sealing' ) AND (mrel = '' or mrel = 'birth' or mrel ='sealing' ) )  ";
			$result = tng_query($query);
			foreach ($result as $ch){
//				$chkme = str_replace('/', '&', $ch['lastname']);
				$checker .= $checker . '&' . $chkme;
				$fids .= $ch['personID'];
			}
		}
		$start = $start +1;
	}
	$families = $checker . $fids;

	return $families;

} //function

function get_pschildrenID ($personID, $tree){
	global $families_table, $children_table;
	$query = "SELECT familyID FROM $families_table WHERE husband = '" . $personID ."' AND gedcom = '" . $tree . "' ";
	$result = tng_query($query);
	return $result;
}

function getMlastnames( $key, $sex, $level, $trail, $dab, $tname ) {
	global $tree, $text, $cms, $righttree;
	$crowchanges = ''; $checkme = ''; $xvar2 = ''; //variables set to null to avoid warning.
	$generations = 50;
	if ($sex == 'F') return '';
	$rval = "&".$tname;
	$self = "husband";
	$spouse = "wife";
	$spouseorder = "husborder";
	$tname2 = $tname . '/';
	$notmarried = 'Not Married';
	if ($notmarried == '' )
		$notmarried = 'x&x';
	if( $spouse )
		$result = getSpouseFamilyData($tree, $self, $key, $spouseorder);
	elseif( $key )
		$result = getSpouseFamilyDataUnion($tree, $key);
	$marrtot = tng_num_rows($result);
	if( !$marrtot && $key){
		$result = getSpouseFamilyDataUnion($tree, $key);
		$self = $spouse = $spouseorder = "";
	}
	if( $result ) {
		$childcounter = 0;
		while( $row = tng_fetch_assoc( $result ) ) {
			$spouserow = array();
			$spousestr = "";
			if( !$spouse )
				$spouse = $row['husband'] == $key ? "wife" : "husband";
			if( $row[$spouse] )
				$spouseresult = getPersonData($tree, $row[$spouse]);
			$result2 = getChildrenData($tree, $row['familyID']);
			$numkids = tng_num_rows( $result2 );
			if( $numkids AND $row['marrtype'] != $notmarried ) {
				while( $crow = tng_fetch_assoc( $result2 ) ) {
					$childcounter++;
					$newtrail = "$trail,{$row['familyID']},{$crow['personID']}";
					$crights = determineLivingPrivateRights($crow, $righttree);
					$crow['allow_living'] = $crights['living'];
					$crow['allow_private'] = $crights['private'];
					$newdab = $dab . "." . $childcounter;
					//$crowchanged = str_replace(' ', '^^@^^', $crow['lastname'] . $crow['personID']); for troubleshooting
					$stophere = 0;
					//$xvar = rtrim(tng_strtolower($crow['lastname']), ' ');
					$xvar = $crow['lastname'];
					//$xvar2 = $xvar . '/';
					if (strpos($xvar, '/') !== false )
						$xvar = str_replace('/', '&', $xvar);
					// echo $xvar2 . ' tname2 ' . $tname2 . ' and $tname ' . $tname . '<br>';
					if ($xvar == '' OR $xvar == $tname ) {
						$stophere == 1; $crowchanged = '';
					}
					else {
						if (stripos($checkme, $xvar) !== false OR $tname == $xvar OR stripos($xvar2, $tname2) !== false)
							$stophere = 1;
						else
							$checkme .= $xvar . ',';
						$crowchanged = str_replace(' ', '^^@^^', rtrim($crow['lastname'],' '));
					}
					if ($stophere != 1 AND $crow['sex'] == 'M' AND ($crow['frel'] == '' OR $crow['frel'] == 'birth' OR $crow['frel'] == 'adopted' ) )
						$rval .= '&' . $crowchanged;
					if( $level < $generations AND ($crow['frel'] == '' OR $crow['frel'] == 'birth' OR $crow['frel'] == 'adopted' ) ) {
						$ind = getMlastnames( $crow['personID'], $crow['sex'], $level + 1, $newtrail, $newdab, $tname );
						if($ind)
							$rval .= str_repeat( "", ($level - 1) * 8 + 2 ) . "$ind";
					}
					else {
						//do union to check for children where person is either husband or wife
						$nxtfams = getSpouseFamilyMinimalUnion($tree, $crow['personID']);
						$nxtkids = 0;
						while($nxtfam = tng_fetch_assoc($nxtfams)) {
							$result3 = countChildren($tree, $nxtfam['familyID']);
							$nxtrow = tng_fetch_assoc($result3);
							$nxtkids += $nxtrow['ccount'];
							tng_free_result($result3);
						}
					}
					$rval .= str_repeat( "", ($level - 1) * 8 );
				} // end while
				if( $numkids ) {
					$rval .= str_repeat( "", ($level - 1) * 8 - 2 );
					$rval .= str_repeat( "", ($level - 1) * 8 - 4 );
				}
			} // if numkids
			elseif( $spousestr )
				$rval .= str_repeat( "", ($level - 1) * 8 - 4 );
			tng_free_result( $result2 );
		} //end while
		tng_free_result( $result );
	} //if result

	return $rval;
} //function

function getDlastnames( $personID, $tree, $tname ) {
include_once('tngdblib.php');
	$check='';
	$generations = 50; $level = 1; $key = $personID;
	$result = getPersonFullPlusDates($tree, $personID);
	if( $result )
		$row = tng_fetch_assoc( $result );
	if( $generations > 1 ) {
		$ind = getMlastnames( $key, $row['sex'], $level + 1, $personID, "1", $tname );
		if($ind) $check = $ind . ' ';
	}
	$rowchanged = str_replace(' ', '^^@^^', $row['lastname']);
	if ($row['lastname'] != '' ){
		if (strpos($check, $rowchanged) !== false OR strpos(tng_strtolower($row['lastname']), $tname) !== false )
			$check = $check;
		else
			$check .= '&' . $rowchanged;
	}
	// else $check .= '&' . $rowchanged . '-' . $tname . '-' . $row['lastname'];
	// $check = $rowchanged;
	return $check;
}

// Just redo the names
function associated_abbreviated( $rootname, $tree, $tname) {
$anames = getDlastnames( $rootname, $tree, $tname); // gets lastnames of all descendants in a string
// Make text string pretty
if (strpos ($anames, '&') !== false ) {
	$anames = str_replace(' ', '', str_replace('/', '&', $anames));
	$excludeme = 'unknown';
	$anames = str_ireplace($excludeme, '', $anames );
	$anames = implode('&', array_iunique(explode('&', $anames)));
	$anames = explode("&", $anames);
	sort($anames);
	$nameamt = count($anames);
    if ($nameamt > 2){
    	$anames = implode("&", $anames);
		$anames = substr($anames, 1);
		$anames = str_replace('&', ', ', $anames);
		$anames = str_replace(' ,', ',', $anames);
		$anames = str_replace('^^@^^', ' ', $anames);
    	  } // more than one name in the string
	else $anames ='';
	}
return $anames;
}


function associated_surnames( $personID, $tree, $tname) {
	global $showall_table;
	$_SESSION['saf_ck_table']=$anames='';
	$last = get_last_dad($personID, $tree) ; // gets first paternal ancestor
    if ($last != '') {
		if ($_SESSION['saf_ck_table'] == '') $_SESSION['saf_ck_table'] = $last;
		$rootQuery = "SELECT root_personID, spellings FROM $showall_table WHERE root_personID = '" . $last ."' AND gedcom = '" . $tree . "'";
		$result = tng_query($rootQuery);
		$rootnumber = tng_num_rows($result);
// echo "<script type='text/javascript'>alert('$rootnumber'+'root');</script>";		
		if ($rootnumber > 0 ) {
			$row = tng_fetch_assoc($result);
			$anames = $row['spellings'];
// echo "<script type='text/javascript'>alert('$anames'+' anames');</script>";	
			$e_anames = tng_real_escape_string($anames);
			if ($tname == '') $tname = 'unknownperson';
				if (strpos($anames,$tname) !== false) {}
				else {
				$anames = associated_abbreviated( $last, $tree, $tname); 
				$e_anames = tng_real_escape_string($anames);
// echo "<script type='text/javascript'>alert('$anames'+' anames');</script>";					
				$rootUQuery = "UPDATE ".$showall_table." 
							   SET spellings = '".$e_anames."'
							   WHERE root_personID = '".$last."' AND gedcom = '".$tree."'			   
							   ";	
				$result = tng_query($rootUQuery);						
				}
			}
		else {		
			$anames = getDlastnames( $last, $tree, $tname); // gets lastnames of all descendants in a string
			// Make text string pretty
//			$c = $anames;
			if (strpos ($anames, '&') !== false ) {
				$anames = str_replace(' ', '', str_replace('/', '&', $anames));
				$excludeme = 'unknown';
				$anames = str_ireplace($excludeme, '', $anames );
				$anames = implode('&', array_iunique(explode('&', $anames)));
//			$c = $anames;
				$anames = explode("&", $anames);
				sort($anames);
				$nameamt = count($anames);
              if ($nameamt > 2){
				$anames = implode("&", $anames);
			$c = $anames;				
				$anames = substr($anames, 1);
				$anames = str_replace('&', ', ', $anames);
				$anames = str_replace(' ,', ',', $anames);
				$anames = str_replace('^^@^^', ' ', $anames);
				$e_anames = tng_real_escape_string($anames);
					if ($_SESSION['saf_ck_table'] != $last) {
					$rootUQuery = 'UPDATE '.$showall_table.'
								   SET root_personID = "'.$last.'", spellings = "'.$e_anames.'"
								   WHERE root_personID = "'.$_SESSION['saf_ck_table'].'" AND gedcom = "'.$tree.'"			   
								   ';	
					$result = tng_query($rootUQuery);		
					}
					else {
					$rootIQuery = 'INSERT INTO '.$showall_table.' (root_personID, gedcom, spellings) VALUES ("'.$last.'", "'.$tree.'","'.$e_anames.'")';
					$result = tng_query($rootIQuery);
					}	
				  } // more than one name in the string
				 if ($nameamt <= 2) $anames = '';
				}
				else $anames = '';
		}
} // if $last != ''
//$anames = $anames . ' - ' . $nameamt.' '.$last. ' '.$tname; //useful for troubleshooting
	return $anames;
}

function gsaf_getallnames ($lastname, $tree){
	global $showall_table;

	$rootQuery = "SELECT root_personID, spellings FROM $showall_table WHERE root_personID = '" . $personID ."' AND gedcom = '" . $tree . "'";
	$result = tng_query($rootQuery);
	$rootnumber = tng_num_rows($result);
	if ($rootnumber > 0) $_SESSION['saf_ck_table'] = $personID;
}

/***********************************************************
    Test if the $showall_table exists. If not, create it      *
***********************************************************/

function check_create_showalltable (){
	global $showall_table;
	$showall_query = "SHOW TABLES LIKE '%$showall_table%'";
	$result = tng_query($showall_query);
	if(tng_num_rows($result) == 0){
		$query = "SELECT @@collation_database AS collation";
		$result = tng_query($query);
		$collation = tng_fetch_assoc($result);
		$collation = $collation['collation'];
		$collationstr = $collation ? "COLLATE $collation" : "";
		$engine = strpos($collation, "utf8mb4") === false ? "MYISAM" : "InnoDb ROW_FORMAT=DYNAMIC";
		$query = "CREATE TABLE $showall_table (
				`safID` int NOT NULL AUTO_INCREMENT PRIMARY KEY,
				`root_personID` varchar(20) NOT NULL,
				INDEX rp (`root_personID`),
 				`gedcom` varchar(60) NOT NULL,
				`spellings` varchar(200) NOT NULL,
				`descendants`int NOT NULL,
				`generations` int NOT NULL,	
				`notes` longtext 
				) ENGINE = $engine $collationstr";				
		$result = tng_query($query);
			if(!$result) return "Table creation failed";
			else return "Table creation successful";
	    }
	   else return "Table already exists"; 
}

function saf_name_simple ($row){
global $tree, $text;
if( $row ) {
	$righttree = checktree($tree);
	$rightbranch = checkbranch($row['branch']);
	$rights = determineLivingPrivateRights($row, $righttree, $rightbranch);
	$row['allow_living'] = $rights['living'];
	$row['allow_private'] = $rights['private'];
	if( $rights['both'] ) {
			$nameprint = getName ($row);
			$dna = '';
			if (function_exists('get_DNA_small')) {
				$dna = get_DNA_small($personID,$tree);
				$dna .= ' ';
			}
			$pstring = "<a href='getperson.php?personID=".$row['personID']."&tree=".$tree."'>".$dna.$nameprint."</a>";
			}
	else $pstring = $text['living'];
}
else $pstring = '';
return $pstring;
}

function saf_name_getperson ($personID){
global $tree, $text;
$result = getPersonFullPlusDates($tree, $personID);
$row = tng_fetch_assoc( $result );
if( $row ) {
	$righttree = checktree($tree);
	$rightbranch = checkbranch($row['branch']);
	$rights = determineLivingPrivateRights($row, $righttree, $rightbranch);
	$row['allow_living'] = $rights['living'];
	$row['allow_private'] = $rights['private'];
	if( $rights['both'] ) {
            $birthdate = "";
            if ( $row['birthdate'] ) $birthdate = "{$text['birthabbr']} " . displayDate($row['birthdate']);
            else if ( $row['altbirthdate'] ) $birthdate = "{$text['chrabbr']} " . displayDate($row['altbirthdate']);
            $place ='';
            if ( $row['birthplace'] ) $place = $row['birthplace'] ;
            else if ( $row['altbirthplace'] ) $place = $row['altbirthplace'] ;
            if($birthdate && $place) $birthdate = "(".$birthdate.", ".$place.")";
            else if ($birthdate) $birthdate = "(".$birthdate.")";
            else if ($place) $birthdate = "(".$place.")";
			$nameprint = getName ($row);
			$dna = '';
			if (function_exists('get_DNA_small')) {
				$dna = get_DNA_small($personID,$tree);
				$dna .= ' ';
			}
			
			$pstring = "<a class='pedlinks' href='getperson.php?personID=".$row['personID']."&tree=".$tree."'>".$dna.$nameprint." ".$birthdate."</a>";
			}
	else $pstring = $text['living'];
}
else $pstring = '';

return $pstring;
}

function get_all_media ($mstring, $tree) {
global $medialinks_table, $media_table;
$marray = explode($mstring, ',');
$sendmedia = array();
foreach ($marray as $personID) {
		$query = "SELECT medialinkID, description, notes, altdescription, altnotes, usecollfolder, mediatypeID, personID, $medialinks_table.mediaID as mediaID, thumbpath, status, plot, eventID, alwayson, path, form, abspath, newwindow, $media_table.gedcom, private
		FROM ($medialinks_table, $media_table)
		WHERE $medialinks_table.personID=\"$personID\" AND $medialinks_table.defphoto=1 
		AND $media_table.mediaID = $medialinks_table.mediaID AND $media_table.gedcom = \"$tree\" AND dontshow != 1";   
       $result = tng_query($query);
       if ($result) {
       		$mediarow = tng_fetch_assoc($result);
       		$sendmedia[] = array('mid'=>$mediarow['mediaID'],'desc'=> $mediarow['mediaID'],'path'=>$mediarow['mediaID']);
       		} 	   
	   }
return $sendmedia;
}

function search_safarray($array, $search_list) { 
   $result = array();
    foreach ($array as $key => $value) {  
        foreach ($search_list as $k => $v) {     
            if (!isset($value[$k]) || $value[$k] != $v) continue 2;
        }    
        $result[] = $value;
    }
  if (empty($result)) $result = '1';
return $result;
}

function lang_eval ($mylanguage) {
$language = strtok($mylanguage, '-');
$language = substr($language, strpos($language, "/") + 1);  
$leval = '';
switch ($language){
	case "English": $leval = 1;	break;
	case "French": $leval = 2; break;
	case "Spanish":	$leval = 2;	break;
	case "Dutch": $leval = 2; break;
	case "German": $leval = 2;	break;
	case "Swedish":	$leval = 1; break;
	case "Norwegian": $leval = 1; break;
	case "Czech": $leval = 2; break;	
}
if ($leval =='') $leval = 1;
return $leval;
}
 

?>
