<?php

/* This file is indebted to Robin Richmond for his code from the Count Descendants mod. 
It returns numbers of descendants and generations for an individual.
*/
  
include("tng_begin.php");
include($subroot . "pedconfig.php");
$_SESSION['destinationpage8'] = $_SESSION['saf_cp'];
$tree = $_GET['tree'];
$personID = $pid = $_GET['personID'];

$countem = array(); //The descendant & spouse counts
$descendants = array(); //All descendants, in order to avoid duplication
$spouses = array(); //All spouses, in order to avoid duplication
$duplicates = array(); //Two dimensions; "count", and "list" in one, and a count and a list in the other.
$level = 1;
$key = $personID;
$generations = 0;

$result = getPersonFullPlusDates($tree, $personID);
if( $result ) {
	$row = tng_fetch_assoc( $result );
	$righttree = checktree($tree);
	$rightbranch = $righttree ? checkbranch($row['branch']) : false;
	$rights = determineLivingPrivateRights($row, $righttree, $rightbranch);
	$row['allow_living'] = $rights['living'];
	$row['allow_private'] = $rights['private'];
}

########## Initialize report counters and lists ##############
$duplicates['s']['count'] = 0; #descendants who married cousins
$duplicates['ss']['count'] = 0; #spouse married more than one descendant
$duplicates['s']['list'] = '';;
for ($l=1; $l<30; $l++) {
	$countem[$l]['d'] = 0; #Descendants in a generation
	$countem[$l]['dl'] = 0; #Living descendants  in a generation
	$countem[$l]['birthlow'] = '9999';
	$countem[$l]['birthhigh'] = '0000';
}
########### Start the report ###########
########## Output the name of the starting person as subheading to the report. No need for a link here.
$countem[1]['d']++;
if ($row['living']) $countem[1]['dl']++; #Count if living
$birthyear = substr($row['birthdatetr'], 0, 4);
if ($birthyear!='0000') {
	$countem[1]['birthlow'] = $birthyear;
	$countem[1]['birthhigh'] = $birthyear;
}
$namestr = "";
if ($generations == 0) $generations = 99;  //Zero means do all
if( $generations > 1 ) {
	$ind = getIndividual( $key, $row['sex'], $level + 1, $namestr );
}

//Step through the generations accumulating the counts.
$dcount = $scount = $dlcount = $slcount = 0;
$dateearly = '9999'; $datelate = '0000';
$patternGeneration = 0;
foreach ($countem as $gen=>$gendata) {
	#quit when we reach a generation with no data.
	if (!$countem[$gen]['d']) break;
	$g1 = $gen-1;
	$dcount += $countem[$gen]['d'];  //Accumulate descendants
	if ($dateearly > $countem[$gen]['birthlow']) $dateearly =  $countem[$gen]['birthlow'];
	if ($datelate < $countem[$gen]['birthhigh']) $datelate =  $countem[$gen]['birthhigh'];
} #end loop through generations
$gens = $g1;
$root1 = "SELECT root_personID FROM $showall_table WHERE root_personID = '".$pid."' AND gedcom = '".$tree."' ";
$result = tng_query($root1);
$rootnumber = tng_num_rows($result);
	if ($rootnumber > 0) {
	$rootUQuery = "UPDATE ".$showall_table."
	SET root_personID = '".$pid."', descendants = '".$dcount."', generations = '".$gens."'
	WHERE root_personID = '".$pid."' AND gedcom = '".$tree."' ";
	$result = tng_query($rootUQuery);
	}
	if ($rootnumber == 0) {
	$rootIQuery = 'INSERT INTO '.$showall_table.' (root_personID, gedcom, descendants, generations) VALUES ("'.$pid.'", "'.$tree.'","'.$dcount.'","'.$gens.'"  )';
	$result = tng_query($rootIQuery);
	}

// send the result
echo $dcount.' ('.$gens.')';

// Main function does all the work
function getIndividual( $key, $sex, $level ) {
	global $tree, $generations, $text, $admtext, $cms, $getperson_url, $righttree;
	global $desctracker_url, $divctr, $display, $excolimg, $descendtext_url, $imgtitle;
	global $countem, $names, $descendants, $spouses, $duplicates;
	global $people_table;
	if( $sex == "M" ) {
		$self = "husband";
		$spouse = "wife";
		$spouseorder = "husborder";
	}
	else if( $sex == "F" ){
		$self = "wife";
		$spouse = "husband";
		$spouseorder = "wifeorder";
	}
	else {
		$self = $spouse = $spouseorder = "";
	}

	if( $spouse )
		$result = getSpouseFamilyMinimal($tree, $self, $key, $spouseorder);
	elseif( $key )
		$result = getSpouseFamilyMinimalUnion($tree, $key);
	$marrtot = tng_num_rows($result);
	if( !$marrtot && $key) {
		$result = getSpouseFamilyMinimalUnion($tree, $key);
		$self = $spouse = $spouseorder = "";
	}

	if( $result ) {
		while( $row = tng_fetch_assoc( $result ) ) {

			$spouserow = array(); #Define an array as an empty record in case there is no spouse in this marriage.
			$spousestr = "";
			if( !$spouse )
				$spouse = $row['husband'] == $key ? "wife" : "husband";
			$spouseID = $row[$spouse];

			$result2 = getChildrenDataPlusDates($tree, $row['familyID']);
			$numkids = tng_num_rows( $result2 );
			if( $numkids ) {
				while( $crow = tng_fetch_assoc( $result2 ) ) {
					//Don't count or drill down if we've seen this person before
					$personID = $crow['personID'];
					if ( !array_key_exists($personID, $descendants) ) {
						//Not seen before; count and mark this descendant.
						$countem[$level]['d']++;
						#Save low and high birth year among descendants for this generation
						$birthyear = substr($crow['birthdatetr'], 0, 4);
						if ($birthyear != '0000') {
							if ($birthyear < $countem[$level]['birthlow'])
								$countem[$level]['birthlow'] = $birthyear;
							if ($birthyear > $countem[$level]['birthhigh'])
								$countem[$level]['birthhigh'] = $birthyear;
						}

						$descendants[$personID] = 1; //Mark this person
						if(!$generations || $level <= $generations ) {
							if (empty($crow['sex'])) $crow['sex'] = 'M';
							$ind = getIndividual( $personID, $crow['sex'], $level + 1);
						}
					} 
				}
			}
			tng_free_result( $result2 );
		}
	}
	tng_free_result( $result );
	return "";
} #end function getIndividual

?>

